current_year <- 18
last_month <- 7

library(pacman)
p_load(filesstrings, glue, readbulk, DataExplorer, tictoc, ggmap, skimr, lubridate, forcats, tidyverse, feather)

if (dir.exists("data")) remove_dir("data")
if (!dir.exists("data")) create_dir("data")

URL <- "https://s3.amazonaws.com/fordgobike-data/2017-fordgobike-tripdata.csv"
download.file(URL, destfile = "./data/2017-fordgobike-tripdata.csv", method="curl")

for (j in 18:current_year) {
  print(j)
  for (i in 1:12) {
    print (i)
    if (j == current_year & i == last_month) break
    #  stop = TRUE
    #  break # Fire the flag, and break the inner loop
  }  
  #if (stop) { break }
}  # Fire the flag, and break the inner loop

for (j in 18:current_year) {
  for (i in 1:12) {
    URL <- glue('https://s3.amazonaws.com/fordgobike-data/20{j}{str_pad(i, width=2, side="left", pad="0")}-fordgobike-tripdata.csv.zip')
    download.file(URL, destfile = glue('./data/20{j}{str_pad(i, width=2, side="left", pad="0")}-fordgobike-tripdata.csv.zip'))
    unzip(glue('./data/20{j}{str_pad(i, width=2, side="left", pad="0")}-fordgobike-tripdata.csv.zip'),exdir="./data")
    fn <- glue('./data/20{j}{str_pad(i, width=2, side="left", pad="0")}-fordgobike-tripdata.csv.zip')
    if (file.exists(fn)) file.remove(fn)
    if (j == current_year & i == last_month) break # break the loop
  }  
}

if(current_year == 19) {  
  for (i in 5:7) {
    URL <- glue('https://s3.amazonaws.com/baywheels-data/2019{str_pad(i, width=2, side="left", pad="0")}-baywheels-tripdata.csv.zip')
    download.file(URL, destfile = glue('./data/2019{str_pad(i, width=2, side="left", pad="0")}-baywheels-tripdata.csv.zip'))
    unzip(glue('./data/2019{str_pad(i, width=2, side="left", pad="0")}-baywheels-tripdata.csv.zip'),exdir="./data")
    fn <- glue('./data/2019{str_pad(i, width=2, side="left", pad="0")}-baywheels-tripdata.csv.zip')
    if (file.exists(fn)) file.remove(fn)
  }
}

remove_dir("data/__MACOSX")

if(current_year == 19) {  
  for (i in 5:7) {
    file.rename(glue('./data/2019{str_pad(i, width=2, side="left", pad="0")}-baywheels-tripdata.csv'), 
                glue('./data/2019{str_pad(i, width=2, side="left", pad="0")}-fordgobike-tripdata.csv') 
    )
  }
}

fordgobike <- readbulk::read_bulk(directory = "data", extension = ".csv") %>% as_tibble()

DataExplorer::introduce(fordgobike)

if (current_year == 19) {
  fordgobike <- fordgobike %>% select(-X) %>%
    mutate(age = year(today()) - member_birth_year,
           year=year(start_time), 
           month=month(start_time), 
           day=day(start_time),
           week_day = wday(start_time, label = TRUE) )
} else
{
  fordgobike <- fordgobike %>% mutate(age = year(today()) - member_birth_year,
                                      year=year(start_time), 
                                      month=month(start_time), 
                                      day=day(start_time),
                                      week_day = wday(start_time, label = TRUE) )
}  

# Test out some different ways to write a dataframe to the harddrive.

# write .Rds

tic()
saveRDS(fordgobike, "data/fordgobike.Rds")
toc()

# write .feather from feather R package

tic()
write_feather(fordgobike, "data/fordgobike.feather")
toc()
